diff --git a/cnab/helm/templates/broker/ingress.yaml b/cnab/helm/templates/broker/ingress.yaml
index 1cb1656..ce61472 100644
--- a/cnab/helm/templates/broker/ingress.yaml
+++ b/cnab/helm/templates/broker/ingress.yaml
@@ -1,33 +1,62 @@
-{{- if .Values.broker.ingress.v1beta1.enabled -}}
-{{- $ingressPath := .Values.broker.ingress.path -}}
+{{- if .Values.broker.ingress.enabled -}}
+{{- $kubeVersion := include "common.capabilities.kubeGitVersion" . -}}
 {{- $serviceName := include "pinot.broker.fullname" . -}}
 {{- $servicePort := .Values.broker.service.port -}}
+{{- if and .Values.broker.ingress.className (not (semverCompare ">=1.18-0" $kubeVersion)) }}
+  {{- if not (hasKey .Values.broker.ingress.annotations "kubernetes.io/ingress.class") }}
+  {{- $_ := set .Values.broker.ingress.annotations "kubernetes.io/ingress.class" .Values.broker.ingress.className}}
+  {{- end }}
+{{- end }}
+{{- if semverCompare ">=1.19-0" $kubeVersion -}}
+apiVersion: networking.k8s.io/v1
+{{- else if semverCompare ">=1.14-0" $kubeVersion -}}
+apiVersion: networking.k8s.io/v1beta1
+{{- else -}}
 apiVersion: extensions/v1beta1
+{{- end }}
 kind: Ingress
 metadata:
   name: {{ $serviceName }}
-{{- if .Values.broker.ingress.annotations }}
-  annotations:
-{{ toYaml .Values.broker.ingress.annotations | indent 4 }}
-{{- end }}
   labels:
 {{- include "pinot.brokerLabels" . | nindent 4 }}
+  {{- with .Values.broker.ingress.annotations }}
+  annotations:
+    {{- toYaml . | nindent 4 }}
+  {{- end }}
 spec:
-{{- if .Values.broker.ingress.tls }}
+  {{- if and .Values.broker.ingress.className (semverCompare ">=1.18-0" $kubeVersion) }}
+  ingressClassName: {{ .Values.broker.ingress.className }}
+  {{- end }}
+  {{- if .Values.broker.ingress.tls }}
   tls:
-{{ toYaml .Values.broker.ingress.tls | indent 4 }}
-{{- end }}
+    {{- range .Values.broker.ingress.tls }}
+    - hosts:
+        {{- range .hosts }}
+        - {{ . | quote }}
+        {{- end }}
+      secretName: {{ .secretName }}
+    {{- end }}
+  {{- end }}
   rules:
     {{- range .Values.broker.ingress.hosts }}
-  - host: {{ . }}
-    http:
-      paths:
-        - path: {{ $ingressPath }}
-          backend:
-            serviceName: {{ $serviceName }}
-            servicePort: {{ $servicePort }}
+    - host: {{ .host | quote }}
+      http:
+        paths:
+          {{- range .paths }}
+          - path: {{ .path }}
+            {{- if and .pathType (semverCompare ">=1.18-0" $kubeVersion) }}
+            pathType: {{ .pathType }}
+            {{- end }}
+            backend:
+              {{- if semverCompare ">=1.19-0" $kubeVersion }}
+              service:
+                name: {{ $serviceName }}
+                port:
+                  number: {{ $servicePort }}
+              {{- else }}
+              serviceName: {{ $serviceName }}
+              servicePort: {{ $servicePort }}
+              {{- end }}
+          {{- end }}
     {{- end }}
 {{- end }}
-
-{{- if .Values.broker.ingress.v1.enabled -}}
-{{- end }}
